// Based on Daniel Shiffman's Example 8-2: Two Car objects

Car myCar1;
Car myCar2; // Two objects!

void setup() 
{
  size(400, 400);
  colorMode(HSB, 360, 100, 100);
  myCar1 = new Car(0, 100, 2); // Parameters go inside the parentheses when the object is constructed.
  myCar2 = new Car(180, 300, 1);
  
  println("hue of car1 is " + myCar1.hue);
  println("hue of car2 is " + myCar2.hue);
}

void draw() 
{
  background(0, 0, 100);
  myCar1.move();
  myCar1.display();
  myCar2.move();
  myCar2.display();
}

// Even though there are multiple objects, we still only need one class. No matter how many cars we make.
class Car 
{ 
  int hue;
  float xpos;
  float ypos;
  float xspeed;

  // The Constructor is defined with arguments.
  Car(color tempHue, float tempYpos, float tempXspeed) 
  { 
    hue = tempHue;
    xpos = 0;
    ypos = tempYpos;
    xspeed = tempXspeed;
  }

  void move() //can be named anything (update(), move(), drive(), etc.)
  {
    xpos = xpos + xspeed;
    if (xpos > width) 
    {
      xpos = 0;
    }
  }

  void display() //can be named anything except "draw()"
  {
    stroke(0);
    fill(hue, 100, 100);
    rect(xpos, ypos, 20, 10);
  }
}